using System;

class SportsCar
{
    private int maxSpeed = 0;
    private int horsepower = 0;
    private static int maxSpeedRequirement = 0;
    private static int horsepowerRequirement = 0;
    
    private string [] legalDrivers = new string [0]; //Exercise 2
    
    public bool SportsCheck()
    {
        if((maxSpeed >= maxSpeedRequirement) && (horsepower >= horsepowerRequirement))
            return true;
        else
            return false;
    }

    public void SetMaxSpeed(int newMaxSpeed)
    {
        maxSpeed = newMaxSpeed;
    }
    
    public int GetMaxSpeed()
    {
        return maxSpeed;
    }
    
    public void SetHorsepower(int newHorsepower)
    {
        horsepower = newHorsepower;
    }
    
    public int GetHorsepower()
    {
        return horsepower;
    }

    public static void SetMaxSpeedRequirement(int newMaxSpeedRequirement)
    {
        maxSpeedRequirement = newMaxSpeedRequirement;
    }
    
    public static int GetMaxSpeedRequirement()
    {
        return maxSpeedRequirement;
    }

    public static void SetHorsepowerRequirement(int newHorsepowerRequirement)
    {
        horsepowerRequirement = newHorsepowerRequirement;
    }
    
    public static int GetHorsepowerRequirement()
    {
        return horsepowerRequirement;
    }
    
     //Exercise 2
    public void SetLegalDrivers(params string [] newLegalDrivers)
    {
        legalDrivers = newLegalDrivers;
    }
    
     //Exercise 2
    public bool DriverCheck(string name)
    {   
        foreach(string tempName in legalDrivers)
        {
            if(tempName == name)
                return true; 
        }
        return false;
    }
    
     //Exercise 3
    public static void GetMinimumRequirements(ref int newMaxSpeed, ref int newHorsepower)
    {
        newMaxSpeed = maxSpeedRequirement;
        newHorsepower = horsepowerRequirement;    
    }
    
     //Exercise 4
    public SportsCar MostPowerful(SportsCar carCompare)
    {
        if(carCompare.GetHorsepower() > this.horsepower)
            return carCompare;
        else
            return this;
    }
     //Exercise 4
    public SportsCar MostPowerful(SportsCar carCompare1, SportsCar carCompare2)
    {
        if(MostPowerful(carCompare1).GetHorsepower() > carCompare2.GetHorsepower())
            return MostPowerful(carCompare1);
        else
            return carCompare2;
    }
}

 //Exercise 3
class Calculator
{
    public static void NumberCruncher()
    {
        int sportsCarMaxSpeedReq = 0;
        int sportsCarHorsePowerReq = 0;
        SportsCar.GetMinimumRequirements(ref sportsCarMaxSpeedReq, ref sportsCarHorsePowerReq);
        
        //number crunch...number crunch...number crunch
        
        Console.WriteLine("Value of sportsCarMaxSpeedReq: {0}", sportsCarMaxSpeedReq);
        Console.WriteLine("Value of sportsCarHorsePowerReq: {0}", sportsCarHorsePowerReq);
    }
}

class Tester
{
    public static void Main()
    {
         //Exercise 1
        SportsCar myCar = new SportsCar();
        SportsCar yourCar = new SportsCar();
         //Calling static methods through class name
        SportsCar.SetMaxSpeedRequirement(200);
        SportsCar.SetHorsepowerRequirement(250);
         //Calling instance methods through object names
        myCar.SetMaxSpeed(170);
        myCar.SetHorsepower(110);
        yourCar.SetMaxSpeed(270);
        yourCar.SetHorsepower(300);
        
        Console.WriteLine("It is {0} that my car is a sports car", myCar.SportsCheck());
        Console.WriteLine("It is {0} that your car is a sports car", yourCar.SportsCheck());
        
         //Exercise 2
        myCar.SetLegalDrivers("Peter", "Ann", "Eric");
        Console.WriteLine("It is {0} that Peter can drive myCar", myCar.DriverCheck("Peter"));
        Console.WriteLine("It is {0} that Josephine can drive myCar", myCar.DriverCheck("Josephine"));
        
         //Exercise 3
        Calculator.NumberCruncher();
        
         //Exercise 4
        SportsCar mostPowerfulCar;
        SportsCar herCar = new SportsCar();
        herCar.SetMaxSpeed(290);
        herCar.SetHorsepower(320);
        mostPowerfulCar = myCar.MostPowerful(yourCar);
        Console.WriteLine("The most powerful car of your car and my car has {0} horsepowers", mostPowerfulCar.GetHorsepower());
        mostPowerfulCar = myCar.MostPowerful(yourCar, herCar); 
        Console.WriteLine("The most powerful car of your car, my car and her car has {0} horsepowers", mostPowerfulCar.GetHorsepower());
    }
}
